
#include "cpu.h"
#include "xgstypes.h"

// CPU State...
int		cpu_reset;
int		cpu_abort;
int		cpu_nmi;
int		cpu_irq;
int		cpu_stop;
int		cpu_wait;
int		cpu_trace;
word32	cpu_cycle_count;
int		cpu_update_period;
dualw	A;	   /* Accumulator		     */
dualw	D;	   /* Direct Page Register      */
byte	P;	   /* Processor Status Register */
int	E;	   /* Emulation Mode Flag       */
dualw	S;	   /* Stack Pointer             */
dualw	X;	   /* X Index Register          */
dualw	Y;	   /* Y Index Register          */
byte	DB;	/* Data Bank Register        */

tPC PC;

void CPU_setUpdatePeriod(int period)
{
	 cpu_update_period = period;
}

void CPU_setTrace(int mode)
{
	 cpu_trace = mode;
}

void CPU_reset(void)
{
	 cpu_reset = 1;
}

void CPU_abort(void)
{
	 cpu_abort = 1;
}

void CPU_nmi(void)
{
	 cpu_nmi = 1;
}

void CPU_addIRQ(void)
{
	( cpu_irq)++;
}

void CPU_clearIRQ(void)
{
	if ( cpu_irq) ( cpu_irq)--;
}
