#ifndef __XGSCPU__
#define __XGSCPU__

#include "xgstypes.h"

   extern   dualw	A;	   /* Accumulator		     */
   extern   dualw	D;	   /* Direct Page Register      */
   extern   byte	P;	   /* Processor Status Register */
   extern   int	E;	   /* Emulation Mode Flag       */
   extern   dualw	S;	   /* Stack Pointer             */
   extern   dualw	X;	   /* X Index Register          */
   extern   dualw	Y;	   /* Y Index Register          */
   extern   byte	DB;	/* Data Bank Register        */

   // CPU.CPP
   extern   int		cpu_reset;
   extern   int		cpu_abort;
   extern   int		cpu_nmi;
   extern   int		cpu_irq;
   extern   int		cpu_stop;
   extern   int		cpu_wait;
   extern   int		cpu_trace;
   extern   word32	cpu_cycle_count;
   extern   int		cpu_update_period;
   extern   tPC PC;

   void CPU_setUpdatePeriod(int period);
   void CPU_setTrace(int mode);
   void CPU_reset(void);
   void CPU_abort(void);
   void CPU_nmi(void);
   void CPU_addIRQ(void);
   void CPU_clearIRQ(void);
   void CPU_run(void);
   void CPU_modeSwitch(void);
   void CPU_debug(void);

#endif 
