
#include "debugger.h"
#include "Xgstypes.h"
#include "Xgsstate.h"
#include "cpu.h"
#include "cpumicro.h"
#include "emul.h"
#include "xgsmemory.h"
#include "adb.h"
#include "adb-drv.h"

char debug_buffer[2048];
long g_lDebugHalt=0;

// DEBUGGER.CPP
char *mnemonics[256] = 
{
"BRK", "ORA", "COP", "ORA", "TSB", "ORA", "ASL", "ORA",
"PHP", "ORA", "ASL", "PHD", "TSB", "ORA", "ASL", "ORA",
"BPL", "ORA", "ORA", "ORA", "TRB", "ORA", "ASL", "ORA",
"CLC", "ORA", "INC", "TCS", "TRB", "ORA", "ASL", "ORA",
"JSR", "AND", "JSL", "AND", "BIT", "AND", "ROL", "AND",
"PLP", "AND", "ROL", "PLD", "BIT", "AND", "ROL", "AND",
"BMI", "AND", "AND", "AND", "BIT", "AND", "ROL", "AND",
"SEC", "AND", "DEC", "TSC", "BIT", "AND", "ROL", "AND",
"RTI", "EOR", "???", "EOR", "MVP", "EOR", "LSR", "EOR",
"PHA", "EOR", "LSR", "PHK", "JMP", "EOR", "LSR", "EOR",
"BVC", "EOR", "EOR", "EOR", "MVN", "EOR", "LSR", "EOR",
"CLI", "EOR", "PHY", "TCD", "JMP", "EOR", "LSR", "EOR",
"RTS", "ADC", "PER", "ADC", "STZ", "ADC", "ROR", "ADC",
"PLA", "ADC", "ROR", "RTL", "JMP", "ADC", "ROR", "ADC",
"BVS", "ADC", "ADC", "ADC", "STZ", "ADC", "ROR", "ADC",
"SEI", "ADC", "PLY", "TDC", "JMP", "ADC", "ROR", "ADC",
"BRA", "STA", "BRL", "STA", "STY", "STA", "STX", "STA",
"DEY", "BIT", "TXA", "PHB", "STY", "STA", "STX", "STA",
"BCC", "STA", "STA", "STA", "STY", "STA", "STX", "STA",
"TYA", "STA", "TXS", "TXY", "STZ", "STA", "STZ", "STA",
"LDY", "LDA", "LDX", "LDA", "LDY", "LDA", "LDX", "LDA",
"TAY", "LDA", "TAX", "PLB", "LDY", "LDA", "LDX", "LDA",
"BCS", "LDA", "LDA", "LDA", "LDY", "LDA", "LDX", "LDA",
"CLV", "LDA", "TSX", "TYX", "LDY", "LDA", "LDX", "LDA",
"CPY", "CMP", "REP", "CMP", "CPY", "CMP", "DEC", "CMP",
"INY", "CMP", "DEX", "WAI", "CPY", "CMP", "DEC", "CMP",
"BNE", "CMP", "CMP", "CMP", "PEI", "CMP", "DEC", "CMP",
"CLD", "CMP", "PHX", "STP", "JML", "CMP", "DEC", "CMP",
"CPX", "SBC", "SEP", "SBC", "CPX", "SBC", "INC", "SBC",
"INX", "SBC", "NOP", "XBA", "CPX", "SBC", "INC", "SBC",
"BEQ", "SBC", "SBC", "SBC", "PEA", "SBC", "INC", "SBC",
"SED", "SBC", "PLX", "XCE", "JSR", "SBC", "INC", "SBC"
};
int addrmodes[256] = 
{
21,  9, 21, 22,  4,  4,  4, 19, 21, 49,  5, 21,  2,  2,  2,  3,	
15,  7, 18, 23,  4, 10, 10,  8,  6, 13,  5,  6,  2, 12, 12, 14,
 2,  9,  3, 22,  4,  4,  4, 19, 21, 49,  5, 21,  2,  2,  2,  3,
15,  7, 18, 23, 10, 10, 10,  8,  6, 13,  5,  6, 12, 12, 12, 14,
 6,  9,  6, 22, 24,  4,  4, 19, 21, 49,  5, 21,  2,  2,  2,  3,
15,  7, 18, 23, 24, 10, 10,  8,  6, 13, 21,  6,  3, 12, 12, 14,
21,  9, 33, 22,  4,  4,  4, 19, 21, 49,  5, 21, 17,  2,  2,  3,
15,  7, 18, 23, 10, 10, 10,  8,  6, 13, 21,  6, 20, 12, 12, 14,
15,  9, 16, 22,  4,  4,  4, 19,  6, 49,  6, 21,  2,  2,  2,  3,
15,  7, 18, 23, 10, 10, 10,  8,  6, 13,  6,  6,  2, 12, 12, 14,
65,  9, 65, 22,  4,  4,  4, 19,  6, 49,  6, 21,  2,  2,  2,  3,
15,  7, 18, 23, 10, 10, 11,  8,  6, 13,  6,  6, 12, 12, 13, 14,
65,  9,  1, 22,  4,  4,  4, 19,  6, 49,  6,  6,  2,  2,  2,  3,
15,  7, 18, 23,  4, 10, 10,  8,  6, 13, 21, 06, 17, 12, 12, 14,
65,  9,  1, 22,  4,  4,  4, 19,  6, 49,  6,  6,  2,  2,  2,  3,
15,  7, 18, 23, 33, 10, 10,  8,  6, 13, 21,  6, 20, 12, 12, 14
};


long FAR PASCAL DEBUGGERWindowProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
   SETFUNCTION("DEBUGGERWindowProc");

   switch(message)
   {

		case WM_CHAR:
			ADB_inputKeyDown((int) wParam, 0);
			break;

		case WM_KEYDOWN:
			ADB_inputKeyDown((int) wParam, 1);
			break;

		case WM_KEYUP:
			ADB_inputKeyRelease((int) wParam, 1);
			break;

      case WM_DESTROY:
            break;
   };
   return DefWindowProc(hWnd, message, wParam, lParam);

} ;

#define DEBUG_WINDOW_NAME  "XGS/32 DEBUGGER"
#define DEBUG_WINDOW_TITLE "XGS/32 DEBUGGER"

HWND  g_DebuggerWnd;
long  lExitDebug=0;

DWORD    g_lDebugRunThreadID;

bool inited=false;

//UINT EMUL_EmulatorRunThread( LPVOID pParam )
DWORD WINAPI DEBUG_RunThread(LPVOID lpParameter)
{
   SETFUNCTION("DEBUGGER_Start");

   WNDCLASS		      wc;
   HRESULT           hr;
   MSG               msg;

   // register an instance of a window class
   wc.style = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc = DEBUGGERWindowProc;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = g_hDLLInstance;
   wc.hIcon = NULL;
   wc.hCursor = NULL;
   wc.hbrBackground = NULL;
   wc.lpszMenuName = NULL;
   wc.lpszClassName = DEBUG_WINDOW_NAME;
   hr = RegisterClass( &wc );

   g_DebuggerWnd = CreateWindowEx(0,DEBUG_WINDOW_NAME,DEBUG_WINDOW_TITLE,WS_OVERLAPPEDWINDOW,1,1,500,300,NULL,NULL,g_hDLLInstance,NULL);

   // if the handle is NULL, then the window was not created...
   if( !g_DebuggerWnd  )
   {
      DoErrorMessage("Unable to Create A Child Debugger Window",1);         
      WriteDebug("Unable To Create Client Debugger Window");
      return 0;
   };

   ShowWindow(g_DebuggerWnd,SW_SHOW);
   inited=true;
   DEBUGGER_Update();

   while (!lExitDebug)
   {
      while (PeekMessage(&msg,g_DebuggerWnd,0,0,PM_REMOVE))
      {
         DEBUGGERWindowProc(msg.hwnd,msg.message,msg.wParam,msg.lParam);
      };
      UpdateWindow(g_DebuggerWnd);
   };

   DestroyWindow(g_DebuggerWnd);
   g_DebuggerWnd=0;
   inited=false;
   UnregisterClass(DEBUG_WINDOW_NAME,g_hDLLInstance);

   return 1;
};

void DEBUGGER_Start()
{
   CreateThread(NULL,NULL,DEBUG_RunThread,NULL,NULL,&g_lDebugRunThreadID);
};


void DEBUGGER_Stop()
{
   lExitDebug=1;
   inited=0;
};

int GetDebuggerString(long bank, long offset, long address, char *pszOpcodeString);
void GetMachineString(char *pszCPUString);

#define DEBUG_WINDOW_LINES       16
#define DEBUG_WINDOW_LINE_SIZE   14

void DEBUGGER_Update()
{

   RECT     rClient;
   long     lX;
   long     lY;
   char     pszOpcodeString[255];
   char     pszCPUString[255];
   char     pszError[12]="Error...\0";
   char     pszDebugLines[DEBUG_WINDOW_LINES*4][255];
   HRESULT  hr;
   HDC      dc;

   if (!inited)
      return;

   dc=GetDC(g_DebuggerWnd);

   GetClientRect(g_DebuggerWnd,&rClient);
   lX = rClient.right;
   lY = rClient.bottom;
   hr = BitBlt(dc,0,0,lX,lY,NULL,0,0,WHITENESS);
   
   long lBank=PC.B.PB;
   long lOffset=PC.W.PC;
   long lAddress=PC.A;
   long lStartLine;
   long lEndLine;
   long lYPos=0;
   
   if (lOffset < (DEBUG_WINDOW_LINES*4))
   {
      lStartLine =0;
      lEndLine = (DEBUG_WINDOW_LINES*4);
   }
   else
   if (lOffset > (0xFFFF-(DEBUG_WINDOW_LINES*4)))
   {
      lStartLine = (0xFFFF-(DEBUG_WINDOW_LINES*4));
      lEndLine = (0xFFFF);
   }
   else
   {
      lStartLine = lOffset - ((DEBUG_WINDOW_LINES/2)*4);
      lEndLine = lOffset + ((DEBUG_WINDOW_LINES/2) * 4);
   };


   // generate a whole slew of lines...
   long     pos=0;
   long     truepos;
   long     inslength=0;
   long     line=lStartLine;
   while (line <= lEndLine)
   {
      inslength = GetDebuggerString(lBank,line,(lBank<<16)|line,pszOpcodeString);
      strcpy(pszDebugLines[pos],pszOpcodeString);
      if (line==lOffset)
         truepos=pos;
      pos++;
      line += inslength;
   };

   // where is the true start line and end line?
   lStartLine = truepos - (DEBUG_WINDOW_LINES/2);
   lEndLine = truepos + (DEBUG_WINDOW_LINES/2);

   if (lStartLine < 0)
   {
      lStartLine=0;
      lEndLine=DEBUG_WINDOW_LINES;  
   };

   if (lEndLine > 0xFFFF)
   {
      lEndLine = 0xFFFF;
      lStartLine = (0xFFFF) - DEBUG_WINDOW_LINES;
   };

   COLORREF cRed = RGB(0xFF,0,0);
   COLORREF cBlack = RGB(0,0,0);

   for (line=lStartLine; line < lEndLine; line++)
   {
      lYPos++;
      if (line == truepos)
         SetTextColor(dc,cRed);
      else
         SetTextColor(dc,cBlack);
      TextOut(dc,10,(14*lYPos),pszDebugLines[line],strlen(pszDebugLines[line]));
   };
   SetTextColor(dc,cBlack);
   GetMachineString(pszCPUString);
   TextOut(dc,10,((lYPos+1)*14),pszCPUString,strlen(pszCPUString));

   ReleaseDC(g_DebuggerWnd,dc);
   UpdateWindow(g_DebuggerWnd);
};

void GetMachineString(char *pszCPUString)
{
	sprintf(pszCPUString,"A=%04X X=%04X Y=%04X S=%04X D=%04X DB=%02X P=%02X E=%1d\n",(int) A.W, (int) X.W,
									   (int) Y.W, (int) S.W,
									   (int) D.W, (int) DB,
									   (int) P, (int) E);
};

int GetDebuggerString(long bank, long offset, long address, char *pszOpcodeString) 
{
	int	opcode;
	int	mode;
	int	operand;
   char  pszTemp[255];
   char  pszTemp2[255];
   int   rv=1;

	opcode = M_READ(address);
	mode = addrmodes[opcode];
   //bank=PC.B.PB;
   //offset=PC.W.PC;

	sprintf(pszOpcodeString,"%02X/%04X    %s  ",(int) bank,(int) offset,mnemonics[opcode]);

   switch (mode) 
   {
		case 0x01:	operand = M_READ(address+1);
				sprintf(pszTemp,"#$%02X        ", operand);
            rv = 2;
				break;
		case 0x21:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"#$%04X      ", operand);
            rv = 3;
				break;
		case 0x31:	
            if (F_getM) 
            {
					operand = M_READ(address+1);
					sprintf(pszTemp,"#$%02X        ", operand);
               rv = 2;
				} 
            else 
            {
					operand = M_READ(address+1) | (M_READ(address+2) << 8);
					sprintf(pszTemp,"#$%04X      ", operand);
               rv = 3;
				}
				break;
		case 0x41:	
            if (F_getX) 
            {
					operand = M_READ(address+1);
					sprintf(pszTemp,"#$%02X        ", operand);
               rv = 2;
				} 
            else 
            {
					operand = M_READ(address+1) | (M_READ(address+2) << 8);
					sprintf(pszTemp,"#$%04X      ", operand);
               rv = 3;
				}
				break;
		case 0x02:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"$%04X       ", operand);
            rv = 3;
				break;
		case 0x03:	operand = M_READ(address+1) | (M_READ(address+2) << 8) | (M_READ(address+3) << 16);
				sprintf(pszTemp,"$%06X     ", operand);
            rv = 4;
				break;
		case 0x04:	operand = M_READ(address+1);
				sprintf(pszTemp,"$%02X         ", operand);
            rv = 2;
				break;
		case 0x05:	sprintf(pszTemp,"            ");
            rv = 1;
				break;
		case 0x06:	sprintf(pszTemp,"            ");
            rv = 1;
				break;
		case 0x07:	operand = M_READ(address+1);
				sprintf(pszTemp,"($%02X),y     ", operand);
            rv = 2;
				break;
		case 0x08:	operand = M_READ(address+1);
				sprintf(pszTemp,"[$%02X],y     ", operand);
            rv = 2;
				break;
		case 0x09:	operand = M_READ(address+1);
				sprintf(pszTemp,"($%02X,x)     ", operand);
            rv = 2;
				break;
		case 0x0A:	operand = M_READ(address+1);
				sprintf(pszTemp,"$%02X,x       ", operand);
            rv = 2;     
				break;
		case 0x0B:	operand = M_READ(address+1);
				sprintf(pszTemp,"$%02X,y       ", operand);
            rv = 2;
				break;
		case 0x0C:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"$%04X,x     ", operand);
            rv = 3;
				break;
		case 0x0D:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"$%04X,y     ", operand);
            rv = 3;
				break;
		case 0x0E:	operand = M_READ(address+1) | (M_READ(address+2) << 8) | (M_READ(address+3) << 16);
				sprintf(pszTemp,"$%06X,x   ", operand);
            rv = 4;
				break;
		case 0x0F:	operand = offset + 2 + (offset_s) M_READ(address+1);
				sprintf(pszTemp,"$%04X       ", operand & 0xFFFF);
            rv = 2;
				break;
		case 0x10:	operand = offset + 3 + (offset_l) (M_READ(address+1) | (M_READ(address+2) << 8));
				sprintf(pszTemp,"$%04X       ", operand & 0xFFFF);
            rv = 3;
				break;
		case 0x11:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"($%04X)     ", operand);
            rv = 3;
				break;
		case 0x12:	operand = M_READ(address+1);
				sprintf(pszTemp,"($%02X)       ", operand);
            rv = 2;
				break;
		case 0x13:	operand = M_READ(address+1);
				sprintf(pszTemp,"[$%02X]       ", operand);
            rv = 2;
				break;
		case 0x14:	operand = M_READ(address+1) | (M_READ(address+2) << 8);
				sprintf(pszTemp,"($%04X,x)   ", operand);
            rv = 3;
				break;
		case 0x15:	sprintf(pszTemp,"            ");
            rv = 1;
				break;
		case 0x16:	operand = M_READ(address+1);
				sprintf(pszTemp,"$%02X,s       ", operand);
            rv = 2;
				break;
		case 0x17:	operand = M_READ(address+1);
				sprintf(pszTemp,"($%02X,s),y   ", operand);
            rv = 2;
				break;
		case 0x18:	
            operand = M_READ(address+1);
				sprintf(pszTemp,"$%02X,",operand);
				operand = M_READ(address+2);
				sprintf(pszTemp2,"$%02X     ",operand);
            strcat(pszTemp,pszTemp2);
            rv = 3;
				break;
	}

   strcat(pszOpcodeString,pszTemp);

   return rv;

}


void CPU_debug(void) 
{
   SETFUNCTION("CPU_debug()");
	int	opcode;
	int	mode;
	int	operand;

	opcode = M_READ(PC.A);
	mode = addrmodes[opcode];
	sprintf(debug_buffer,"%02X/%04X    %s  ",(int) PC.B.PB,(int) PC.W.PC,mnemonics[opcode]);
   WriteDebug(debug_buffer);	
   switch (mode) 
   {
		case 0x01:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"#$%02X        ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x21:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"#$%04X      ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x31:	if (F_getM) {
					operand = M_READ(PC.A+1);
					sprintf(debug_buffer,"#$%02X        ", operand);
               WriteDebug(debug_buffer);
				} else {
					operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
					sprintf(debug_buffer,"#$%04X      ", operand);
               WriteDebug(debug_buffer);
				}
				break;
		case 0x41:	if (F_getX) {
					operand = M_READ(PC.A+1);
					sprintf(debug_buffer,"#$%02X        ", operand);
               WriteDebug(debug_buffer);
				} else {
					operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
					sprintf(debug_buffer,"#$%04X      ", operand);
               WriteDebug(debug_buffer);
				}
				break;
		case 0x02:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"$%04X       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x03:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8) | (M_READ(PC.A+3) << 16);
				sprintf(debug_buffer,"$%06X     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x04:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"$%02X         ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x05:	sprintf(debug_buffer,"            ");
				break;
		case 0x06:	sprintf(debug_buffer,"            ");
				break;
		case 0x07:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"($%02X),y     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x08:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"[$%02X],y     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x09:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"($%02X,x)     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0A:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"$%02X,x       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0B:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"$%02X,y       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0C:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"$%04X,x     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0D:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"$%04X,y     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0E:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8) | (M_READ(PC.A+3) << 16);
				sprintf(debug_buffer,"$%06X,x   ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x0F:	operand = PC.W.PC + 2 + (offset_s) M_READ(PC.A+1);
				sprintf(debug_buffer,"$%04X       ", operand & 0xFFFF);
            WriteDebug(debug_buffer);
				break;
		case 0x10:	operand = PC.W.PC + 3 + (offset_l) (M_READ(PC.A+1) | (M_READ(PC.A+2) << 8));
				sprintf(debug_buffer,"$%04X       ", operand & 0xFFFF);
            WriteDebug(debug_buffer);
				break;
		case 0x11:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"($%04X)     ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x12:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"($%02X)       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x13:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"[$%02X]       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x14:	operand = M_READ(PC.A+1) | (M_READ(PC.A+2) << 8);
				sprintf(debug_buffer,"($%04X,x)   ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x15:	sprintf(debug_buffer,"            ");
				break;
		case 0x16:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"$%02X,s       ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x17:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"($%02X,s),y   ", operand);
            WriteDebug(debug_buffer);
				break;
		case 0x18:	operand = M_READ(PC.A+1);
				sprintf(debug_buffer,"$%02X,",operand);
            WriteDebug(debug_buffer);
				operand = M_READ(PC.A+2);
				sprintf(debug_buffer,"$%02X     ",operand);
            WriteDebug(debug_buffer);
				break;
	}
	sprintf(debug_buffer,"A=%04X X=%04X Y=%04X S=%04X D=%04X DB=%02X P=%02X E=%1d\n",(int) A.W, (int) X.W,
									   (int) Y.W, (int) S.W,
									   (int) D.W, (int) DB,
									   (int) P, (int) E);
   WriteDebug(debug_buffer);
	fflush(stdout);
}

