#ifndef __XGSDEFS__
#define __XGSDEFS__

   #define _XGSDEBUG_
   #define _XGSDEBUG_DISPLAYSOURCEINFO    0
   #define STRING_BUFFER_SIZE             256

   #define  EMUL_RUNNING         0
   #define  EMUL_IDLE            1
   #define  EMUL_PAUSED          2
   #define  EMUL_DOPAUSE         4
   #define  EMUL_DOQUIT          8
   #define  EMUL_DORESUME        16
   
   #ifdef _XGSDEBUG_
      #define SETFUNCTION(pszString)   static char __pszDebugFunctionName[128]=pszString 
	   #define WriteDebug(pszString)	                                                                                       \
      {                                                                                                                    \
         if (g_pDebugFile)                                                                                                 \
         {                                                                                                                 \
            if ((g_pDebugFile) && (g_lDebugMode>0) && (pszString))                                                         \
            {                                                                                                              \
               if (_XGSDEBUG_DISPLAYSOURCEINFO)                                                                            \
                  sprintf(g_pszDebugString,"%s[%d]->%s():  %s\n",__FILE__,__LINE__,__pszDebugFunctionName,pszString);      \
               else                                                                                                        \
                  sprintf(g_pszDebugString,"%s():  %s\n",__pszDebugFunctionName,pszString);                                \
               fprintf(g_pDebugFile,"%s",g_pszDebugString);                                                                \
               fflush(g_pDebugFile);                                                                                       \
            }                                                                                                              \
         }                                                                                                                 \
      }

      #define  WRITEERRORSTRING(errnum,stringmsg)     { sprintf(emul_buffer,"%s: hr=0x%XD\n",stringmsg,errnum); WriteDebug(emul_buffer); }
   #else
      #define SETFUNCTION(pszString)               
	   #define WriteDebug(pszString)                
      #define  WRITEERRORSTRING(errnum,stringmsg)  
   #endif

   #define NUM_SMPT_DEVS	      14
   
   #define M_READ(a)	            MEM_readMem(a)
   #define M_WRITE(a,v)	         MEM_writeMem(a,v)
   #define E_UPDATE(v)	         EMUL_hardwareUpdate(v)
   #define E_WDM(v)	            EMUL_handleWDM(v)

   #define PIXEL  byte
   #define VID_PIXEL_SUPER       0
   #define VID_PIXEL_TEXT        1
   #define VID_PIXEL_BORDER      2
   #define VID_PIXEL_HIRES       3
   #define VID_PIXEL_DBL         4
   #define VID_WIDTH	            640
   #define VID_HEIGHT	         400
   #define VID_STATUS_FONT	      "8x13"
   #define VID_CLASS PseudoColo
   #define VID_MODE_40TEXT1	0
   #define VID_MODE_40TEXT2	1
   #define VID_MODE_80TEXT1	2
   #define VID_MODE_80TEXT2	3
   #define VID_MODE_LORES1		4
   #define VID_MODE_LORES2		5
   #define VID_MODE_DLORES1	6
   #define VID_MODE_DLORES2	7
   #define VID_MODE_HIRES1		8
   #define VID_MODE_HIRES2		9
   #define VID_MODE_DHIRES1	10
   #define VID_MODE_DHIRES2	11
   #define VID_MODE_SUPER		12

   #define WINDOW_NAME                       "XGS/32 Host"
   #define WINDOW_TITLE                      "XGS/32 Host"
   #define GETSCREENADDR(x,y)                (vid_lines[y] + (x*BYTESPERPIXEL))
   #define BYTESPERPIXEL                     (g_lVidBitDepth/8)
   #define GETRGB24(red,green,blue)          ((blue) + ((green)<<8) + ((red)<<16))
   #define LOOKUPSUPERCOLOR24(ColorIndex)    GETRGB24(((slow_memory[(0x019E00+(ColorIndex*2))+1] & 0x0F) * 17),(((slow_memory[(0x019E00+(ColorIndex*2))] >> 4) & 0x0F) * 17),((slow_memory[(0x019E00+(ColorIndex*2))] & 0x0F) * 17))
   #define LOOKUPBORDERCOLOR24(ColorIndex)   GETRGB24(vid_textcolors[vid_bordercolor].red,vid_textcolors[vid_bordercolor].green,vid_textcolors[vid_bordercolor].blue)
   #define LOOKUPTEXTCOLOR24(colorval)       GETRGB24(g_pDDPaletteEntry[colorval].peRed,g_pDDPaletteEntry[colorval].peGreen,g_pDDPaletteEntry[colorval].peBlue)
   #define RED16(p)                          (p >> g_RGB16DEF.Position.rgbRed)                              // Extracts Red Component
   #define GREEN16(p)                        ((p & g_RGB16DEF.Mask.rgbGreen) >> g_RGB16DEF.Position.rgbGreen)  // Extracts Green Component
   #define BLUE16(p)                         (p & g_RGB16DEF.Mask.rgbBlue)                                 // Extracts Blue Component
   #define GETRGB16(r, g, b)                 ((r << g_RGB16DEF.Position.rgbRed) | (g << g_RGB16DEF.Position.rgbGreen) | b) 
   #define LOOKUPSUPERCOLOR16(ColorIndex)    GETRGB16(((slow_memory[(0x019E00+(ColorIndex*2))+1] & 0x0F) * 17),(((slow_memory[(0x019E00+(ColorIndex*2))] >> 4) & 0x0F) * 17),((slow_memory[(0x019E00+(ColorIndex*2))] & 0x0F) * 17))
   #define LOOKUPBORDERCOLOR16(ColorIndex)   GETRGB16(vid_textcolors[vid_bordercolor].red,vid_textcolors[vid_bordercolor].green,vid_textcolors[vid_bordercolor].blue)
   #define LOOKUPTEXTCOLOR16(colorval)       GETRGB16(g_pDDPaletteEntry[colorval].peRed,g_pDDPaletteEntry[colorval].peGreen,g_pDDPaletteEntry[colorval].peBlue)
   #define VID_putPixel(x,y,ColorIndex,PixelType) (*VID_PixelPlot[PixelType])(x,y,ColorIndex)
   #define  DDCHECKCOM(funccall,stringmsg)         { hr = funccall; if FAILED(hr) { WRITEERRORSTRING(hr,stringmsg); DoErrorMessage(stringmsg); return hr; }; }
   #define  DDCHECKCOMNR(funccall,stringmsg)       { hr = funccall; if FAILED(hr) { WRITEERRORSTRING(hr,stringmsg); DoErrorMessage(stringmsg); }; }

   /* This is the difference (in seconds) between the IIGS's time	*/
   /* (secs since 1/1/04 00:00:00) and Unix time (secs since	*/
   /* 1/1/70 00:00:00).						*/
   #define	CLK_OFFSET	2082826800

   #define MEM_FLAG_SHADOW_E0	   0x0001
   #define MEM_FLAG_SHADOW_E1	   0x0002
   #define MEM_FLAG_IO		      0x0004
   #define MEM_FLAG_SPECIAL	   0x0008
   #define MEM_FLAG_INVALID	   0x8000

   #define ADB_VERSION	6
   #define ADB_INPUT_BUFFER	128
   #define ADB_IN_BUFFSIZE

   #define IMAGE_MAGIC	"2IMG"
   #define IMAGE_CR_XGS	"XGS!"
   #define IMAGE_IF_RAW_DO	0
   #define IMAGE_IF_RAW_PO	1
   #define IMAGE_IF_NIBBLE	2
   #define IMAGE_FL_LOCKED	0x80000000
   #define IMAGE_TYPE_2IMG	0	/* 2IMG Universal Format	*/
   #define IMAGE_TYPE_RAW	1	/* Raw (headerless) image, with	*/
   #define IMAGE_TYPE_DC42	2	/* DiskCopy 4.2			*/

   #define NUM_IWM_DEVS	4
   #define AVG_NIB_AREA_525	(2*0x1900)
   #define LEN_NIB_AREA_525	(2*0x2000)
   #define LEN_NIB_IMG_TRK_525	6656
   #define LEN_NIB_SECTOR_35	(2*800)

   #define CPU_DISPATCH

   #define IRQ_STACK_SIZE		   256
   #define SAMPLE_RATE			   28000
   #define MAXSOUNDBUFFERSIZE    28000
   #define MAXSOUNDBUFFERS	      256

#endif